settings = {
	click = function(x, y)
		if x >= 140 and x < 235 and y >= 103 and y < 124 then
			sounds.enabled = not sounds.enabled
			sounds.play("clck")
			settings.repaint()
		elseif x >= 188 and x < 322 and y >= 80 and y < 101 then
			local newVolume = math.floor(((x - 192) / 5) + 0.5)
			if newVolume < 0 then newVolume = 0 end
			if newVolume > 25 then newVolume = 25 end
			audio.volume(newVolume)
			sounds.play("clck")
			settings.repaint()
		end
	end,
	touchDown = function(x, y)
		if x >= 188 and x < 322 and y >= 80 and y < 101 then
			settings.volumeDownX = x
			settings.volumeDownVolume = audio.volume()
		end
	end,
	touchMove = function(x, y)
		if settings.volumeDownX then
			local newVolume = settings.volumeDownVolume + math.floor(((x - settings.volumeDownX) / 5) + 0.5)
			if newVolume < 0 then newVolume = 0 end
			if newVolume > 25 then newVolume = 25 end
			audio.volume(newVolume)
			settings.repaint()
		end
	end,
	touchUp = function(x, y)
		settings.volumeDownX = nil
		settings.volumeDownVolume = nil
	end,
	repaint = function()
	
		-- Redraw the settings background.
		img = image.load("images/dialog/captions/settings.png")
		img:draw(140, 58)
		img:close()
	
		-- Draw the sound enabled value.
		if sounds.enabled then
			img = image.load("images/checkbox-checked.png")
		else
			img = image.load("images/checkbox.png")
		end
		img:draw(140, 107)
		img:close()
		
		-- Draw the volume slider.
		img = image.load("images/slider.png")
		img:draw(188 + audio.volume() * 5, 80)
		img:close()
		
		screen.update()
	end,
	show = function()
		sounds.play("clck")
		
		-- Override default methods.
		dialog.touchClick = settings.click
		dialog.touchDown = settings.touchDown
		dialog.touchMove = settings.touchMove
		dialog.touchUp = settings.touchUp		
		dialog.shown = settings.repaint
		
		-- Show the dialog.
		dialog.show("settings", { "ok" }, "sound")
		
		-- Restore default methods.
		dialog.touchClick = nil
		dialog.touchDown = nil
		dialog.touchMove = nil
		dialog.touchUp = nil
		dialog.shown = nil
	end
}